Index: /trunk/BNC/bnccaster.cpp
===================================================================
--- /trunk/BNC/bnccaster.cpp	(revision 627)
+++ /trunk/BNC/bnccaster.cpp	(revision 628)
@@ -178,9 +178,9 @@
   qRegisterMetaType<p_obs>("p_obs");
 
-  connect(getThread, SIGNAL(newObs(const QByteArray, bool, p_obs)),
-          this,      SLOT(newObs(const QByteArray, bool, p_obs)));
-
-  connect(getThread, SIGNAL(error(const QByteArray)), 
-          this, SLOT(slotGetThreadError(const QByteArray)));
+  connect(getThread, SIGNAL(newObs(QByteArray, bool, p_obs)),
+          this,      SLOT(newObs(QByteArray, bool, p_obs)));
+
+  connect(getThread, SIGNAL(error(QByteArray)), 
+          this, SLOT(slotGetThreadError(QByteArray)));
 
   _staIDs.push_back(getThread->staID());
@@ -190,5 +190,5 @@
 // Error in get thread
 ////////////////////////////////////////////////////////////////////////////
-void bncCaster::slotGetThreadError(const QByteArray staID) {
+void bncCaster::slotGetThreadError(QByteArray staID) {
   QMutexLocker locker(&_mutex);
   _staIDs.removeAll(staID);
Index: /trunk/BNC/bnccaster.h
===================================================================
--- /trunk/BNC/bnccaster.h	(revision 627)
+++ /trunk/BNC/bnccaster.h	(revision 628)
@@ -44,13 +44,13 @@
 
  public slots:
-   void newObs(const QByteArray staID, bool firstObs, p_obs obs);
+   void newObs(QByteArray staID, bool firstObs, p_obs obs);
 
  signals:
    void getThreadErrors();   
-   void newMessage(const QByteArray& msg);
+   void newMessage(QByteArray msg);
 
  private slots:
    void slotNewConnection();
-   void slotGetThreadError(const QByteArray staID);
+   void slotGetThreadError(QByteArray staID);
 
  private:
Index: /trunk/BNC/bncgetthread.h
===================================================================
--- /trunk/BNC/bncgetthread.h	(revision 627)
+++ /trunk/BNC/bncgetthread.h	(revision 628)
@@ -51,8 +51,8 @@
 
  signals:
-   void newBytes(const QByteArray staID, double nbyte);
-   void newObs(const QByteArray staID, bool firstObs, p_obs obs);
-   void error(const QByteArray staID);
-   void newMessage(const QByteArray msg);
+   void newBytes(QByteArray staID, double nbyte);
+   void newObs(QByteArray staID, bool firstObs, p_obs obs);
+   void error(QByteArray staID);
+   void newMessage(QByteArray msg);
 
  protected:
Index: /trunk/BNC/bncmain.cpp
===================================================================
--- /trunk/BNC/bncmain.cpp	(revision 627)
+++ /trunk/BNC/bncmain.cpp	(revision 628)
@@ -123,6 +123,6 @@
 
     app.connect(caster, SIGNAL(getThreadErrors()), &app, SLOT(quit()));
-    app.connect(caster, SIGNAL(newMessage(const QByteArray&)), 
-                &app, SLOT(slotMessage(const QByteArray&)));
+    app.connect(caster, SIGNAL(newMessage(QByteArray)), 
+                &app, SLOT(slotMessage(QByteArray)));
   
     ((bncApp*)qApp)->slotMessage("============ Start BNC ============");
@@ -140,6 +140,6 @@
       QByteArray nmea = hlp[4].toAscii();
       bncGetThread* getThread = new bncGetThread(url, format, latitude, longitude, nmea, iMount);
-      app.connect(getThread, SIGNAL(newMessage(const QByteArray&)), 
-                  &app, SLOT(slotMessage(const QByteArray&)));
+      app.connect(getThread, SIGNAL(newMessage(QByteArray)), 
+                  &app, SLOT(slotMessage(const QByteArray)));
 
       caster->addGetThread(getThread);
Index: /trunk/BNC/bncwindow.cpp
===================================================================
--- /trunk/BNC/bncwindow.cpp	(revision 627)
+++ /trunk/BNC/bncwindow.cpp	(revision 628)
@@ -523,8 +523,8 @@
           this, SLOT(slotGetThreadErrors()));
 
-  connect(_caster, SIGNAL(newMessage(const QByteArray&)), 
-          this, SLOT(slotMessage(const QByteArray&)));
-  connect(_caster, SIGNAL(newMessage(const QByteArray&)), 
-          (bncApp*)qApp, SLOT(slotMessage(const QByteArray&)));
+  connect(_caster, SIGNAL(newMessage(QByteArray)), 
+          this, SLOT(slotMessage(QByteArray)));
+  connect(_caster, SIGNAL(newMessage(QByteArray)), 
+          (bncApp*)qApp, SLOT(slotMessage(QByteArray)));
 
   slotMessage("============ Start BNC ============");
@@ -543,12 +543,12 @@
     bncGetThread* getThread = new bncGetThread(url, format, latitude, longitude, nmea, iRow);
 
-    connect(getThread, SIGNAL(newMessage(const QByteArray&)), 
-            this, SLOT(slotMessage(const QByteArray&)));
-    connect(getThread, SIGNAL(newMessage(const QByteArray&)), 
-            (bncApp*)qApp, SLOT(slotMessage(const QByteArray&)));
-
-    connect(getThread, SIGNAL(newBytes(const QByteArray, double)),
+    connect(getThread, SIGNAL(newMessage(QByteArray)), 
+            this, SLOT(slotMessage(QByteArray)));
+    connect(getThread, SIGNAL(newMessage(QByteArray)), 
+            (bncApp*)qApp, SLOT(slotMessage(QByteArray)));
+
+    connect(getThread, SIGNAL(newBytes(QByteArray, double)),
             (bncTableItem*) _mountPointsTable->item(iRow, 6), 
-            SLOT(slotNewBytes(const QByteArray, double)));
+            SLOT(slotNewBytes(QByteArray, double)));
 
     _caster->addGetThread(getThread);