Index: trunk/BNC/bnchelp.html
===================================================================
--- trunk/BNC/bnchelp.html	(revision 597)
+++ trunk/BNC/bnchelp.html	(revision 640)
@@ -18,6 +18,4 @@
 <a href=#limits>4. Limitations</a><br>
 <a href=#authors>5. Authors</a><br>
-<a href=#history>6. History</a><br>
-<a href=#links>7. Links</a><br>
 <a href=#annex>8. Annex</a><br>
 </h4>
@@ -64,5 +62,6 @@
 &nbsp; &nbsp; &nbsp; 3.4.1. <a href=#wait>Wait for Full Epoch</a><br>
 &nbsp; &nbsp; &nbsp; 3.4.2. <a href=#ascii>ASCII Output File</a><br>
-&nbsp; &nbsp; &nbsp; 3.4.3. <a href=#binary>Port for Binary Output</a><br>
+&nbsp; &nbsp; &nbsp; 3.4.3. <a href=#obsbin>Port for Binary Observation Output</a><br>
+&nbsp; &nbsp; &nbsp; 3.4.4. <a href=#ephascii>Port for ASCII Ephemeris Output</a><br>
 3.5. <a href=#rinex>RINEX</a><br>
 &nbsp; &nbsp; &nbsp; 3.5.1. <a href=#rnxname>RINEX File Names</a><br>
@@ -158,8 +157,8 @@
 </p>
 <p>
-Beware that the size of this file can rapidly inrease depending on the number of incoming streams. This option is primarily meant for testing and evaluation.
-</p>
-
-<p><a name="binary"><h4>3.4.3 Port for Binary Output - optional</h4></p>
+Beware that the size of this file can rapidly increase depending on the number of incoming streams. This option is primarily meant for testing and evaluation.
+</p>
+
+<p><a name="obsbin"><h4>3.4.3 Port for Binary Observation Output - optional</h4></p>
 <p>
 BNC can produce synchronized observations in binary format on your local host (IP 127.0.0.1) through an IP port. Specify an IP port number here to activate this function. The default is an empty option field, meaning that no binary output is generated.</p>
@@ -205,4 +204,7 @@
 <p>The source code for BNC comes with an example program called 'test_bnc_qt.cpp' that allows you to read BNC's binary output from the IP port.</p>
 
+<p><a name="ephascii"><h4>3.4.4 Port for ASCII Ephemeris Output - optional</h4></p>
+BNC can output broadcast ephemeris in binary format on your local host (IP 127.0.0.1) through an IP port. Specify an IP port number to activate this function. The default is an empty option field, meaning that no ASCII ephemeris output via IP port is generated.</p>
+</p>
 <p><a name="rinex"><h4>3.5. RINEX</h4></p>
 <p>
@@ -489,5 +491,19 @@
 </p>
 
-<p><a name="history"><h3>6. History</h3></p>
+<p><a name="annex"><h3>8. Annex</h3></p>
+<p>
+8.1. <a href=#history>History</a><br>
+8.2. <a href=#ntrip>NTRIP</a><br>
+&nbsp; &nbsp; &nbsp; 8.2.1 <a href=#source>Source-table</a><br>
+8.3. <a href=#rtcm>RTCM</a><br>
+&nbsp; &nbsp; &nbsp; 8.3.1 RTCM <a href=#rtcm2> Version 2.x</a><br>
+&nbsp; &nbsp; &nbsp; 8.3.2 RTCM <a href=#rtcm3> Version 3.x</a><br>
+8.4. <a href=#rtigs>RTIGS</a><br>
+&nbsp; &nbsp; &nbsp; 8.4.1 <a href=#soc>SOC</a><br>
+8.5. <a href=#config>Config File</a><br>
+8.6. <a href=#links>Links</a><br>
+</p>
+
+<p><a name=history><h3>8.1 History</h3></p>
 <table>
 <tr></tr>
@@ -497,33 +513,9 @@
 <tr><td>May 2007 &nbsp;</td><td>Version 1.3 &nbsp;</td><td>[Add] Source code published.
 <tr><td>Jul 2007 &nbsp;</td><td>Version 1.4 &nbsp;</td><td>[Bug] Skip messages from proxy server<br> [Bug] Call RINEX script through 'nohup'</td></tr>
-<tr><td>Nov 2007 &nbsp;</td><td>Version 1.5 &nbsp;</td><td>[Add] Handle Ephemeris from RTCM Version 3.x streams<br> [Add] Upgrade to Qt Version 4.3.2<br> [Add] Optional RINEX v3 output<br> [Add] SBAS support</td></tr>
+<tr><td>Dec 2007 &nbsp;</td><td>Version 1.5 &nbsp;</td><td>[Add] Handle Ephemeris from RTCM Version 3.x streams<br> [Add] Upgrade to Qt Version 4.3.2<br> [Add] Optional RINEX v3 output<br> [Add] SBAS support</td></tr>
 </table>
 </p>
 
-<p><a name="links"><h3>7. Links</h3></p>
-<table>
-<tr></tr>
-<tr><td>NTRIP &nbsp;</td><td><u>http://igs.bkg.bund.de/index_ntrip.htm</u></td></tr>
-<tr><td>EUREF-IP NTRIP broadcaster &nbsp;</td><td><u>http://www.euref-ip.net/home</u></td></tr>
-<tr><td>IGS-IP NTRIP broadcaster &nbsp;</td><td><u>http://www.igs-ip.net/home</u></td></tr>
-<tr><td>NTRIP broadcaster overview &nbsp;</td><td><u>http://www.rtcm-ntrip.org/home</u></td></tr>
-<tr><td>EUREF-IP Project &nbsp;</td><td><u>http://www.epncb.oma.be/euref_IP</u></td></tr>
-<tr><td>Real-time IGS Pilot Project &nbsp;</td><td><u>http://www.rtigs.net/pilot</u></td></tr>
-<tr><td>Radio Technical Commission<br>for Maritime Services &nbsp;</td><td><u>http://www.rtcm.org</u>
-</table>
-
-<p><a name="annex"><h3>8. Annex</h3></p>
-<p>
-8.1. <a href=#ntrip>NTRIP</a><br>
-&nbsp; &nbsp; &nbsp; 8.1.1 <a href=#source>Source-table</a><br>
-8.2. <a href=#rtcm>RTCM</a><br>
-&nbsp; &nbsp; &nbsp; 8.2.1 RTCM <a href=#rtcm2> Version 2.x</a><br>
-&nbsp; &nbsp; &nbsp; 8.2.2 RTCM <a href=#rtcm3> Version 3.x</a><br>
-8.3. <a href=#rtigs>RTIGS</a><br>
-&nbsp; &nbsp; &nbsp; 8.3.1 <a href=#soc>SOC</a><br>
-8.4. <a href=#config>Config File</a>
-</p>
-
-<p><a name="ntrip"><h4>8.1. NTRIP</h4></p>
+<p><a name="ntrip"><h4>8.2. NTRIP</h4></p>
 
 <p>
@@ -550,5 +542,5 @@
 </p>
 
-<p><a name="source"><h4>8.1.1 Source-table</h4></p>
+<p><a name="source"><h4>8.2.1 Source-table</h4></p>
 
 <p>
@@ -566,5 +558,5 @@
 </p>
 
-<p><a name="rtcm"><h4>8.2. RTCM</h4></p>
+<p><a name="rtcm"><h4>8.3. RTCM</h4></p>
 
 <p>
@@ -574,5 +566,5 @@
 </p>
 
-<p><a name="rtcm2"><h4>8.2.1 RTCM Version 2.x</h4></p>
+<p><a name="rtcm2"><h4>8.3.1 RTCM Version 2.x</h4></p>
 <p>
 Transmitting GNSS carrier phase data can be done through RTCM Version 2.x messages. Please note that only RTCM Version 2.2 and 2.3 streams may include GLONASS data. Messages that may be of some interest here are:
@@ -612,5 +604,5 @@
 </ul>
 
-<p><a name="rtcm3"><h4>8.2.2 RTCM Version 3.x</h4></p>
+<p><a name="rtcm3"><h4>8.3.2 RTCM Version 3.x</h4></p>
 <p>
 RTCM Version 3.x has been developed as a more efficient alternative to RTCM Version 2.x. Service providers and vendors have asked for a standard that would be more efficient, easy to use, and more easily adaptable to new situations. The main complaint was that the Version 2 parity scheme was wasteful of bandwidth. Another complaint was that the parity is not independent from word to word. Still another was that even with so many bits devoted to parity, the actual integrity of the message was not as high as it should be. Plus, 30-bit words are awkward to handle. The Version 3.x standard is intended to correct these weaknesses.
@@ -640,5 +632,5 @@
 </ul>
 
-<p><a name="rtigs"><h4>8.3. RTIGS</h4></p>
+<p><a name="rtigs"><h4>8.4. RTIGS</h4></p>
 <p>
 RTIGS stands for a data format and transport protocol for GPS observations. It was defined by the Real-Time IGS Working Group (RTIGS WG). Its definition is based on the SOC format. Every RTIGS record has one of the following numbers:
@@ -693,5 +685,5 @@
 </p>
 
-<p><a name="soc"><h4>8.3.1 SOC</h4></p>
+<p><a name="soc"><h4>8.4.1 SOC</h4></p>
 <p>
 The SOC format has been designed in July 1999 by the Jet Propulsion Laboratory (JPL) and the California Institute of Technology (CalTech) to transport 1Hz GPS data with minimal bandwidth over the open Internet. SOC follows the 'little-endian' byte order meaning that the low-order byte of a number is stored in memory at the lowest address, and the high-order byte at the highest address. Because the transport layer is UDP, the format does not include sync bits, a checksum, or cyclic redundancy checksum (CRC). SOC allows to transport the GPS observable CA, P1, P2, L1, and L2, efficiently compressed down to 14 bytes with 1 mm range resolution and 0.02 mm phase resolution. SOC contains epochs for cycle slips, a stand-alone time-tag per epoch, a minimum representation of the receiver's clock solution, 3 SNR numbers, a unique site id, a modulo 12 hour sequence number and flags for receiver type and GPS health. SOC's simple structure comprises an 8 byte header, a 9 byte overhead for timetag, number of gps, etc., plus 21 data bytes per gps.
@@ -702,5 +694,5 @@
 <p>
 </p>
-<p><a name="config"><h4>8.4. Config File</h4></p>
+<p><a name="config"><h4>8.5. Config File</h4></p>
 <p>
 The following is an example for the contents of a Unix/Linux configuration file ${HOME}/.config/BKG/BKG_NTRIP_Client.conf. It enables the retrieval of stream ACOR0 form www.euref-ip.net and FFMJ3 from www.igs-ip.net for the generation of 15 min RINEX files. RINEX files are uploaded to an archive using script 'up2archive' :
@@ -731,2 +723,14 @@
 </p>
 
+<p><a name="links"><h3>8.6 Links</h3></p>
+<table>
+<tr></tr>
+<tr><td>NTRIP &nbsp;</td><td><u>http://igs.bkg.bund.de/index_ntrip.htm</u></td></tr>
+<tr><td>EUREF-IP NTRIP broadcaster &nbsp;</td><td><u>http://www.euref-ip.net/home</u></td></tr>
+<tr><td>IGS-IP NTRIP broadcaster &nbsp;</td><td><u>http://www.igs-ip.net/home</u></td></tr>
+<tr><td>NTRIP broadcaster overview &nbsp;</td><td><u>http://www.rtcm-ntrip.org/home</u></td></tr>
+<tr><td>EUREF-IP Project &nbsp;</td><td><u>http://www.epncb.oma.be/euref_IP</u></td></tr>
+<tr><td>Real-time IGS Pilot Project &nbsp;</td><td><u>http://www.rtigs.net/pilot</u></td></tr>
+<tr><td>Radio Technical Commission<br>for Maritime Services &nbsp;</td><td><u>http://www.rtcm.org</u>
+</table>
+